# Gamma Toolbox

[![PyPI version](https://badge.fury.io/py/gamma-cli.svg)](https://badge.fury.io/py/gamma-cli)
![PyPI - Downloads](https://img.shields.io/pypi/dm/gamma-cli?style=plastic)
[![Build Status](https://dev.azure.com/nielsfreier/gamma-cli/_apis/build/status/freier-niels.gamma-cli?branchName=master)](https://dev.azure.com/nielsfreier/gamma-cli/_build/latest?definitionId=1&branchName=master)
[![Maintainability Rating](https://sonarcloud.io/api/project_badges/measure?project=gamma-cli&metric=sqale_rating)](https://sonarcloud.io/dashboard?id=gamma-cli)
[![Reliability Rating](https://sonarcloud.io/api/project_badges/measure?project=gamma-cli&metric=reliability_rating)](https://sonarcloud.io/dashboard?id=gamma-cli)
[![Security Rating](https://sonarcloud.io/api/project_badges/measure?project=gamma-cli&metric=security_rating)](https://sonarcloud.io/dashboard?id=gamma-cli)
[![Coverage](https://sonarcloud.io/api/project_badges/measure?project=gamma-cli&metric=coverage)](https://sonarcloud.io/dashboard?id=gamma-cli)

Gamma's toolbox used to bootstrap new projects and for all the common operations.

Full documentation: <https://git.sourceai.io/pages/freier-niels/gamma-cli/>

## Installation

`pip3 install gamma-cli`

## Usage

### to see the commands

`gamma`

### To login with Github

`gamma login`

you will be prompted your token, you need to create one on: <https://git.sourceai.io/settings/tokens>

The token will be saved to be used with other commands

### To create a new project

`gamma new project`

`gamma new project --path /tmp/`

### To create a new Trello board

`gamma new trello`

### To request a new VM

`gamma new vm`

You will be prompted few options for your project then if you want to init
a git project and to push the first commit to Github.

### to create a .gitignore file

`gamma gitignore options` to get the available options

`gamma gitignore generate python flask > .gitignore` to generate a .gitgnore file in the current directory

## Update

The tool is automatically checking at every run if a newer version exist and display
a warning to the user about the need to update.

The version if exposed here: <https://gist.github.com/stumpyfr/b4f89c297a4e479049ff463fed790b37>
and automatically updated by the CI when the project version is bump and a new release is published.

## telemetry

The project is sending telemetry of two types:

* usage with event for each actions (<https://azure.microsoft.com/en-us/services/monitor/)>
* exception in case of crash (<https://sentry.io>)

The data is used to allow us to understand the usage of the tool and be able to quickly fix issues.

If you want to opt-out from the telemetry, you need to use the `--no-telemetry` options or set the environement variable `NO_TELEMETRY=True`

## Code formater

The project is using `black` for the code formating: <https://github.com/psf/black>

## Version bumping

The project is using `punch` to handle the version bumping: <https://github.com/lgiordani/punch>
